org.springframework.beans.factory.annotation

## Annotation Type Lookup

-     @Target(value=METHOD)
       @Retention(value=RUNTIME)
       @Documented
      public @interface Lookup

  An annotation that indicates 'lookup' methods, to be overridden by the container to redirect them back to the `BeanFactory` for a `getBean` call. This is essentially an annotation-based version of the XML `lookup-method` attribute, resulting in the same runtime arrangement.

  The resolution of the target bean can either be based on the return type (`getBean(Class)`) or on a suggested bean name (`getBean(String)`), in both cases passing the method's arguments to the `getBean` call for applying them as target factory method arguments or constructor arguments.

  Such lookup methods can have default (stub) implementations that will simply get replaced by the container, or they can be declared as abstract - for the container to fill them in at runtime. In both cases, the container will generate runtime subclasses of the method's containing class via CGLIB, which is why such lookup methods can only work on beans that the container instantiates through regular constructors: i.e. lookup methods cannot get replaced on beans returned from factory methods where we cannot dynamically provide a subclass for them.

  Recommendations for typical Spring configuration scenarios: When a concrete class may be needed in certain scenarios, consider providing stub implementations of your lookup methods. And please remember that lookup methods won't work on beans returned from `@Bean` methods in configuration classes; you'll have to resort to `@Inject Provider<TargetBean>` or the like instead.

  Since:
    4.1
  Author:
    Juergen Hoeller
  See Also:
    `BeanFactory.getBean(Class, Object...)`, `BeanFactory.getBean(String, Object...)`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `String` | `value` This annotation attribute may suggest a target bean name to look up.

- - ### Element Detail

    - #### value

          public abstract String value

      This annotation attribute may suggest a target bean name to look up. If not specified, the target bean will be resolved based on the annotated method's return type declaration.
      Default:
        ""